/*	Pong Par Whyp
	Ce programme a ete compil sous Turbo C++ 3.0 et Tasm 5.0
	Me contactez : www.ifrance.com/latanniere
	Whyp@ifrance.com
*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#pragma inline

void aff_pixel(unsigned short int x, unsigned short int y,char state)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov ax,0x1A20;
	asm mov es,ax;
	asm mov al,state;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm and es:[si],ah;
	asm mov ah,al;
	asm rol ah,cl;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}

void inv_pixel(unsigned short int x, unsigned short int y,char state)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov ax,0x1A60;
	asm mov es,ax;
	asm mov al,state;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm and es:[si],ah;
	asm mov ah,al;
	asm rol ah,cl;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}


void aff_ball(unsigned short int x,unsigned short int y, char state)
	{
	inv_pixel(x,y,state);
	x=x-1;
	inv_pixel(x,y,state);
	x=x+2;
	inv_pixel(x,y,state);
	y=y-1;
	inv_pixel(x,y,state);
	x=x-1;
	inv_pixel(x,y,state);
	x=x-1;
	inv_pixel(x,y,state);
	y=y+2;
	inv_pixel(x,y,state);
	x=x+1;
	inv_pixel(x,y,state);
	x=x+1;
	inv_pixel(x,y,state);
	}

void hline(int x1,int x2,int y)
	{
	int i;
	for(i=x1;i<=x2;i++) aff_pixel(i,y,1);
	}

void vline(int x,int y1,int y2)
	{
	int i;
	for(i=y1;i<=y2;i++) aff_pixel(x,i,1);
	}

int waitkey(void)
	{
	int v=getch();
	if (v==0) v=getch();
	return v;
	}

void locate(int x,int y,char st[])
	{
	gotoxy(x,y);
	printf(st);
	}
void charct(int x,int y,int dec_value)
	{
	gotoxy(x,y);
	printf("%c",dec_value);
	}
void Cadre(void)
	{
	int i;
	clrscr();
	for (i=1;i<21;i++)
		{
		locate(i,1,"*");
		locate(i,8,"*");
		}
	for (i=2;i<8;i++)
		{
		locate(1,i,"*");
		locate(20,i,"*");
		}
	}
int getNbr(void)
	{int i;int val=0;int k=0;
	for(i=0;k!=28;i++)
		{while((k<48||k>57)&&(k!=28||i==0)) k=getch();
		if (k!=28) {putchar(k);val=val*10+k-48;k=0;}}
	return val;}

void clrgfx(void)
	{asm push ax;
	asm mov ax,0x0000;
	asm	int 10h;
	asm pop ax;}

void main(void)
{
	int key=0,tmp=30,tmp1=30,X=55,Y=30,pad1=25,pad2=25,nbpl=1,i,p1=0,p2=0,X1,Y1,upg=60,downg=61,upd=62,downd=63;
	randomize();
menu:	Cadre();
	locate(7,2,"Pong v1.3"); 	/* affiche le menu */
	locate(4,3,"[F1] Options");
	locate(4,4,"[F2] 1 Player");
	locate(4,5,"[F3] 2 Player");
	locate(4,6,"[F4] Exit");
	locate(12,7,"Par Whyp");
	gotoxy(1,1);
intro:	switch (waitkey())            	/* attend une touche */
		{
		case 61 : nbpl=2;
		case 60 : break;
		case 59 :
			{
			Cadre();
			locate(4,3,"[F1] Delay");
			locate(4,4,"[F2] Touches");
			switch (waitkey())
				{
				case 59 : Cadre();
					  locate(4,3,"Delay :");
					  locate(4,7,"Default=50");
					  gotoxy(4,5);
					  tmp=getNbr();
					  tmp1=tmp;
					  gotoxy(3,6);
					  printf("Nv delay : %d",tmp);
					  waitkey();
					  goto menu;
				case 60 : Cadre();
					  gotoxy(4,3);
					  printf("%c droit  :",24);
					  printf(" %c",upg=waitkey());
					  gotoxy(4,4);
					  printf("%c droit  :",25);
					  printf(" %c",downg=waitkey());
					  gotoxy(4,5);
					  printf("%c gauche :",24);
					  printf(" %c",upd=waitkey());
					  gotoxy(4,6);
					  printf("%c gauche :",25);
					  printf(" %c",downd=waitkey());
				default : goto menu;
				}
			}
		case 62 : goto exit;
		default : goto intro;
		}
	key=0;
IA:	if (nbpl==1)
		{
		Cadre();
		locate(3,3,"IA:");
		locate(3,4,"[F1] Conne");
		locate(3,5,"[F2] Moin Conne");
		switch (waitkey())
			{
			case 60 : nbpl=4;
			case 59 : break;
			case 61 : nbpl=3;
				  break;
			default : goto IA;
			}
		}

/* dessine raquette et cadre */
start:	clrgfx();
	vline(5,25,35);
	vline(4,25,35);
	vline(121,25,35);
	vline(122,25,35);
	hline(1,127,63);
	hline(1,127,63);
	for (i=1;i<=63;i+=8) vline(64,i,i+4);
	aff_ball(X,Y,1);
	gotoxy(2,1);
	printf("%d",p1);
	gotoxy(18,1);
	printf("%d",p2);
	X1=rand()%2;
	if (X1!=1) X1=-1;
	Y1=rand()%2;
	if (Y1!=1) Y1=-1;

Debut:  /* delay(tmp); */
	while (tmp1!=0) tmp1--;
	tmp1=tmp;
	while (kbhit()) key=waitkey();  /* detecte une touche */
	if (key==59)
		{
		goto fin;
		}
	while (kbhit()) key=waitkey();
	if (key==upg && pad1!=3)
		{
		pad1--;
		aff_pixel(5,pad1,1);
		aff_pixel(4,pad1,1);
		aff_pixel(5,pad1+11,0);
		aff_pixel(4,pad1+11,0);
		key=0;
		}
	if (key==downg && pad1!=52)
		{
		pad1++;
		aff_pixel(5,pad1-1,0);
		aff_pixel(4,pad1-1,0);
		aff_pixel(5,pad1+10,1);
		aff_pixel(4,pad1+10,1);
		key=0;
		}
	while (kbhit()) key=waitkey();
	if (key==upd && pad2!=3 && nbpl==2)
		{
		pad2--;
		aff_pixel(121,pad2,1);
		aff_pixel(122,pad2,1);
		aff_pixel(121,pad2+11,0);
		aff_pixel(122,pad2+11,0);
		key=0;
		}
	while (kbhit()) key=waitkey();
	if (key==downd && pad2!=52  && nbpl==2)
		{
		pad2++;
		aff_pixel(121,pad2-1,0);
		aff_pixel(122,pad2-1,0);
		aff_pixel(121,pad2+10,1);
		aff_pixel(122,pad2+10,1);
		key=0;
		}

	if (nbpl==1)
		{
		if ((Y-pad2)<0 && pad2!=3)
			{
			pad2--;
			aff_pixel(121,pad2,1);
			aff_pixel(122,pad2,1);
			aff_pixel(121,pad2+11,0);
			aff_pixel(122,pad2+11,0);
			}
		if ((Y-pad2)>10 && pad2!=52)
			{
			pad2++;
			aff_pixel(121,pad2-1,0);
			aff_pixel(122,pad2-1,0);
			aff_pixel(121,pad2+10,1);
			aff_pixel(122,pad2+10,1);
			}
		}

	if (nbpl==4)
		{
		if (Y1<0 && pad2!=3 && (Y-pad2)<5)
			{
			pad2--;
			aff_pixel(121,pad2,1);
			aff_pixel(122,pad2,1);
			aff_pixel(121,pad2+11,0);
			aff_pixel(122,pad2+11,0);
			}
		if (Y1>0 && pad2!=52 && (Y-pad2)>5)
			{
			pad2++;
			aff_pixel(121,pad2-1,0);
			aff_pixel(122,pad2-1,0);
			aff_pixel(121,pad2+10,1);
			aff_pixel(122,pad2+10,1);
			}
		}
	while (kbhit()) key=waitkey();
	if (nbpl>=3)
		{
		if (Y1<0 && pad2!=3 && (Y-pad2)<5)
			{
			pad2--;
			aff_pixel(121,pad2,1);
			aff_pixel(122,pad2,1);
			aff_pixel(121,pad2+11,0);
			aff_pixel(122,pad2+11,0);
			}
		if (Y1>0 && pad2!=52 && (Y-pad2)>5)
			{
			pad2++;
			aff_pixel(121,pad2-1,0);
			aff_pixel(122,pad2-1,0);
			aff_pixel(121,pad2+10,1);
			aff_pixel(122,pad2+10,1);
			}
		}
affbal:	aff_ball(X,Y,0);        	/* efface la balle */
	if (Y<3 || Y>60) Y1=-Y1;
	if (X==7 && (Y-pad1+Y1)>=0 && (Y-pad1+Y1)<=10)
		{
		switch  (Y-pad1+Y1)
			{
			case 1 :
			case 2 : Y1=-2;
				 X1=1;
				 break;
			case 3 :
			case 4 : Y1=-1;
				 X1=1;
				 break;
			case 5 :
			case 6 : Y1=-Y1;
				 X1=2;
				 break;
			case 7 :
			case 8 : Y1=1;
				 X1=1;
				 break;
			case 9 :
			case 10: Y1=2;
				 X1=1;
			}
		}
	while (kbhit()) key=waitkey();
	if (X==119 && (Y-pad2+Y1)>=0 && (Y-pad2+Y1)<=10)
		{
		switch  (Y-pad2+Y1)
			{
			case 1 :
			case 2 : Y1=-2;
				 X1=-1;
				 break;
			case 3 :
			case 4 : Y1=-1;
				 X1=-1;
				 break;
			case 5 :
			case 6 : Y1=-Y1;
				 X1=-2;
				 break;
			case 7 :
			case 8 : Y1=1;
				 X1=-1;
				 break;
			case 9 :
			case 10: Y1=2;
				 X1=-1;
			}
		}
	if (X==125)
		{
		p1++;
		goto fin;
		}
	if (X==1)
		{
		p2++;
		goto fin;
		}
	X=X+X1;
	Y=Y+Y1;
	aff_ball(X,Y,1);                /* affiche la balle */
	goto Debut;
fin:	Cadre();
	locate(3,3,"Pour continuez");
	locate(3,4,"appuyez sur une");
	locate(3,5,"touche...");
	locate(3,7,"[F1] Exit\n");
	key=waitkey();
	X=55;
	Y=30;
	pad1=25;
	pad2=25;
	X1=-1;
	Y1=1;
	if (key!=59) goto start;
exit:	Cadre();
	locate(3,3,"Salut...");
	locate(5,5,"www.ifrance.com");
	locate(9,6,"/latanniere");
	locate(4,7,"Whyp@ifrance.com");
	getch();
}
